package database

import (
	"fmt"

	"git.paulbsd.com/paulbsd/coronafana/src/config"
	"git.paulbsd.com/paulbsd/coronafana/src/coronafana"
	"xorm.io/xorm"
	"xorm.io/xorm/names"
)

// InitDatabase ...
func InitDatabase(cfg *config.Config) (err error) {
	var tables = []interface{}{
		new(coronafana.Coronaglobaldata),
		new(coronafana.Coronapaysdata),
	}

	cfg.Db, err = xorm.NewEngine("postgres",
		fmt.Sprintf("user=%s password=%s host=%s dbname=%s sslmode=disable",
			cfg.DbUsername,
			cfg.DbPassword,
			cfg.DbHostname,
			cfg.DbName))
	if err != nil {
		return
	}

	cfg.Db.SetMapper(names.GonicMapper{})
	cfg.Db.ShowSQL(cfg.Debug)

	for _, object := range tables {
		err = cfg.Db.Sync2(object)
		if err != nil {
			return
		}
	}
	return
}
